local CIR = CooldownIconsR
local tinsert = tinsert
local GetTime = _G.GetTime
local LCI = LibStub("LibCooldownIcons") -- this is more a personal utility lib (provides some 'extra' functions or extended standard ones)

local function CooldownByCmd(watch,wtype)
	if wtype=='spell' then
		return GetSpellCooldown(watch)
	else
		return GetItemCooldown(watch)
	end
end
local icondb
CIR.OnCooldown = { }

function CIR:SPELL_UPDATE_COOLDOWN(event)
	if not icondb then
		icondb = CIR.db.char.icondb
	end
	if not self.OnCooldown then
		self.OnCooldown={}
	end
	for obj,t in pairs(self.icons) do
		if LCI:inTable(obj,self.events[event]) then
			local script = self.db.char.icondb[obj].script
			self:ProcessScriptForIcon(script,t)
		end
		local watch,wtype = t.watch, t.type
		if watch and wt~="disabled" then
			local start,duration = CooldownByCmd(watch,wtype)
			if start and duration then
				local now = GetTime()
				local isRunningCooldown,num = LCI:inTable(obj,self.OnCooldown)
				if not t.displayType then
					t.displayType = icondb[obj].iDisplayType or 1
				end
				if not t.timeFormat then
					t.timeFormat = icondb[obj].iTimeFormat or 1
				end
				if not runningCooldown and now<=(start+(duration-2)) then
					tinsert(self.OnCooldown,obj)
					if icondb[obj].iGrayscale and not t.forcedgray then
						t.texture:SetDesaturated(1)
					end
				elseif isRunningCooldown and now>(start+duration) then
					tremove(self.OnCooldown,num)
					t.text:SetText("")
					if not t.forcedgray then
						t.texture:SetDesaturated(0)
					end
				end
			end
		end
	end
end


local updater = CreateFrame("Frame","CIR_Updater",UIParent)
updater:SetScript("OnUpdate",function(self,elapsed)
	if not CIR.updateFrequency then return end
	if not self.lastUpdate then
		self.lastUpdate = 0
	end
	self.lastUpdate = self.lastUpdate+elapsed
	while(self.lastUpdate >= CIR.updateFrequency) do
		local toRem = { }
		for num,obj in ipairs(CIR.OnCooldown) do
			local icon = CIR.icons[obj]
			if not icon.displayType then
				icon.displayType = icondb[obj].iDisplayType or 1
			end
			if not icon.timeFormat then
				icon.timeFormat = icondb[obj].iTimeFormat or 1
			end
			local start,duration = CooldownByCmd(icon.watch,icon.type)
			if GetTime()<=(start+duration) then
				icon:SetTime(start,duration)
			elseif GetTime() > (start+duration) then
				if not icon.forcedgray then
					icon.texture:SetDesaturated(0)
				end
				icon.text:SetText("")
				tinsert(toRem,num)
			end
		end
		while #toRem>0 do
			if CIR.icons[CIR.OnCooldown[toRem[1]]] then
				CIR.icons[CIR.OnCooldown[toRem[1]]].text:SetText("")
			end
			tremove(CIR.OnCooldown,toRem[1])
			tremove(toRem,1)
			if #toRem==0 then
				CIR:SPELL_UPDATE_COOLDOWN()
			end
		end
		self.lastUpdate = self.lastUpdate - CIR.updateFrequency
	end
end)


